<?php 

    // CHCK IF UPLOAD BUTTON CLICKED!
    if(isset($_POST['upload']))
    {
        // CHECK IF ANY FILE SELECTED OR NOT
        if($_FILES['image']['name'] == "")
        {
            $msg = "Please select a file";
        }else
        {
            // GET FILE EXTENTION IN SMALL CASE
            $file_ext = strtolower(pathinfo($_FILES['image']['name'], PATHINFO_EXTENSION));
            
            // GET FILE SIZE, IT WILL RETURN IN BYTES BUT WE WILL CONVERT IT TO KILOBYTES
            $file_size = $_FILES['image']['size'] / 1024;

            // ARRAY OF VALID EXTENIONS
            $valid_ext = ['png', 'jpg','jpeg'];

            // VALIDATE IF FILE EXTENSION IS MATCH WITH ANY OF VALID EXTENSION
            if(in_array($file_ext, $valid_ext))
            {
                // VALIDATE FILE SIZE, SELECTED PICTURE SHOULD NOT BE GREATER THAN 2MB
                if($file_size > 2048)
                {
                    $msg = "File Size Should Not Be Greater Than 2MB.";
                }else
                {
                    // NOW EVERYTHING IS VALIDE, LETS CREATE NEW FILE NAME.
                    $file_new_name = time().".".$file_ext;

                    // LET'S UPLOAD FILE TO FOLDER, AND IF YOU WANT TO SAVE IT TO DATABASE TABLE YOU CAN SAVE $file_new_name
                    $result = move_uploaded_file($_FILES['image']['tmp_name'], "images/".$file_new_name);

                    // CHECK IF FILE UPLOADED OR NOT
                    if($result)
                    {
                        $msg = "File Uploaded Successfully!";
                    }else
                    {
                        $msg = "Something Went Wrong, We Couldnt Upload Your File.";
                    }
                }
            }else
            {
                $msg = "Invalid File Extension, Please Choose, png, jpg or jpeg File!";
            }
        }
    }
?>

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="css/style.css">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.1.1/css/all.min.css" integrity="sha512-KfkfwYDsLkIlwQp6LFnl8zNdLGxu9YAA1QvwINks4PhcElQSvqcyVLLD9aMhXd13uQjoXtEKNosOWaZqXgel0g==" crossorigin="anonymous" referrerpolicy="no-referrer" />
    <title>File Upload</title>
</head>
<body>
    <form action="<?php  $_SERVER['PHP_SELF']?>" id="file_upload_form" method="POST" enctype="multipart/form-data">
        <input type="file" name="image">
        <button name="upload"><i class="fa-solid fa-upload"></i></button>
    </form>
    
    <?php if(isset($msg)) { ?><div id="msg"><?php echo $msg ?></div> <?php }?>
    
</body>
</html>